Index: boot/Makefile.grub
===================================================================
--- boot/Makefile.grub	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ boot/Makefile.grub	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -52,8 +52,8 @@
 $(BOOT_OUTPUT): build_dist
 ifeq ($(GRUB_ARCH),pc)
-	$(GENISOIMAGE) -J -r -input-charset utf-8 -V "HelenOS boot ISO" -eltorito-boot $(ELTORITO) -no-emul-boot -boot-load-size 64 -boot-info-table -o $@ $(DISTROOT)/
+	mkisofs -J -r -input-charset utf-8 -V "HelenOS boot ISO" -eltorito-boot $(ELTORITO) -no-emul-boot -boot-load-size 64 -boot-info-table -o $@ $(DISTROOT)/
 endif
 ifeq ($(GRUB_ARCH),efi)
-	$(GENISOIMAGE) -J -r -input-charset utf-8 -V "HelenOS boot ISO" -efi-boot $(ELTORITO) -o $@ $(DISTROOT)/
+	mkisofs -J -r -input-charset utf-8 -V "HelenOS boot ISO" -efi-boot $(ELTORITO) -o $@ $(DISTROOT)/
 endif
 
Index: boot/Makefile.silo
===================================================================
--- boot/Makefile.silo	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ boot/Makefile.silo	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -41,5 +41,5 @@
 
 $(POST_OUTPUT): build_dist
-	$(GENISOIMAGE) -f -G $(ISOFS_B_IN) -B ... -r -o $@ $(DISTROOT)/
+	mkisofs -f -G $(ISOFS_B_IN) -B ... -r -o $@ $(DISTROOT)/
 
 build_dist: clean
Index: boot/Makefile.yaboot
===================================================================
--- boot/Makefile.yaboot	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ boot/Makefile.yaboot	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -40,5 +40,5 @@
 
 $(POST_OUTPUT): build_dist
-	$(GENISOIMAGE) -hfs -part -map $(MAPS) -no-desktop -hfs-volid "HelenOS" -hfs-bless $(DISTROOT)/boot -r -o $@ $(DISTROOT)/
+	mkisofs -hfs -part -map $(MAPS) -no-desktop -hfs-volid "HelenOS" -hfs-bless $(DISTROOT)/boot -r -o $@ $(DISTROOT)/
 
 build_dist: clean
Index: kernel/arch/abs32le/src/abs32le.c
===================================================================
--- kernel/arch/abs32le/src/abs32le.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ kernel/arch/abs32le/src/abs32le.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -49,4 +49,5 @@
 #include <syscall/syscall.h>
 #include <console/console.h>
+#include <sysinfo/sysinfo.h>
 #include <memstr.h>
 
Index: kernel/arch/amd64/include/interrupt.h
===================================================================
--- kernel/arch/amd64/include/interrupt.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ kernel/arch/amd64/include/interrupt.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -55,4 +55,5 @@
 #define IRQ_PIC_SPUR  7
 #define IRQ_MOUSE     12
+#define IRQ_NE2000    9
 
 /* This one must have four least significant bits set to ones */
Index: kernel/arch/amd64/src/amd64.c
===================================================================
--- kernel/arch/amd64/src/amd64.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ kernel/arch/amd64/src/amd64.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -214,8 +214,22 @@
 		}
 	}
+	
+	/*
+	 * This is the necessary evil until the userspace driver is entirely
+	 * self-sufficient.
+	 */
+	sysinfo_set_item_val("i8042", NULL, true);
+	sysinfo_set_item_val("i8042.inr_a", NULL, IRQ_KBD);
+	sysinfo_set_item_val("i8042.inr_b", NULL, IRQ_MOUSE);
+	sysinfo_set_item_val("i8042.address.physical", NULL,
+	    (uintptr_t) I8042_BASE);
+	sysinfo_set_item_val("i8042.address.kernel", NULL,
+	    (uintptr_t) I8042_BASE);
 #endif
 	
 	if (irqs_info != NULL)
 		sysinfo_set_item_val(irqs_info, NULL, true);
+	
+	sysinfo_set_item_val("netif.ne2000.inr", NULL, IRQ_NE2000);
 }
 
Index: kernel/arch/arm32/src/arm32.c
===================================================================
--- kernel/arch/arm32/src/arm32.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ kernel/arch/arm32/src/arm32.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -38,4 +38,5 @@
 #include <genarch/fb/fb.h>
 #include <abi/fb/visuals.h>
+#include <sysinfo/sysinfo.h>
 #include <console/console.h>
 #include <ddi/irq.h>
Index: kernel/arch/ia32/include/interrupt.h
===================================================================
--- kernel/arch/ia32/include/interrupt.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ kernel/arch/ia32/include/interrupt.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -55,4 +55,5 @@
 #define IRQ_PIC_SPUR  7
 #define IRQ_MOUSE     12
+#define IRQ_NE2000    5
 
 /* This one must have four least significant bits set to ones */
Index: kernel/arch/ia32/src/ia32.c
===================================================================
--- kernel/arch/ia32/src/ia32.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ kernel/arch/ia32/src/ia32.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -168,8 +168,22 @@
 		}
 	}
+	
+	/*
+	 * This is the necessary evil until the userspace driver is entirely
+	 * self-sufficient.
+	 */
+	sysinfo_set_item_val("i8042", NULL, true);
+	sysinfo_set_item_val("i8042.inr_a", NULL, IRQ_KBD);
+	sysinfo_set_item_val("i8042.inr_b", NULL, IRQ_MOUSE);
+	sysinfo_set_item_val("i8042.address.physical", NULL,
+	    (uintptr_t) I8042_BASE);
+	sysinfo_set_item_val("i8042.address.kernel", NULL,
+	    (uintptr_t) I8042_BASE);
 #endif
 	
 	if (irqs_info != NULL)
 		sysinfo_set_item_val(irqs_info, NULL, true);
+	
+	sysinfo_set_item_val("netif.ne2000.inr", NULL, IRQ_NE2000);
 }
 
Index: kernel/arch/ia32/src/mm/frame.c
===================================================================
--- kernel/arch/ia32/src/mm/frame.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ kernel/arch/ia32/src/mm/frame.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -46,6 +46,4 @@
 #include <print.h>
 
-#define PHYSMEM_LIMIT32  UINT64_C(0x100000000)
-
 size_t hardcoded_unmapped_ktext_size = 0;
 size_t hardcoded_unmapped_kdata_size = 0;
@@ -58,16 +56,15 @@
 		uint64_t base64 = e820table[i].base_address;
 		uint64_t size64 = e820table[i].size;
-		
+
 #ifdef KARCH_ia32
 		/*
 		 * Restrict the e820 table entries to 32-bits.
 		 */
-		if (base64 >= PHYSMEM_LIMIT32)
+		if (base64 >= 0x100000000ULL)
 			continue;
-		
-		if (base64 + size64 > PHYSMEM_LIMIT32)
-			size64 = PHYSMEM_LIMIT32 - base64;
+		if (base64 + size64 > 0x100000000ULL)
+			size64 -= base64 + size64 - 0x100000000ULL;
 #endif
-		
+
 		uintptr_t base = (uintptr_t) base64;
 		size_t size = (size_t) size64;
Index: kernel/arch/ia64/include/interrupt.h
===================================================================
--- kernel/arch/ia64/include/interrupt.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ kernel/arch/ia64/include/interrupt.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -61,4 +61,5 @@
 #define IRQ_KBD    (0x01 + LEGACY_INTERRUPT_BASE)
 #define IRQ_MOUSE  (0x0c + LEGACY_INTERRUPT_BASE)
+#define IRQ_NE2000 (0x09 + LEGACY_INTERRUPT_BASE)
 
 /** General Exception codes. */
Index: kernel/arch/ia64/src/ia64.c
===================================================================
--- kernel/arch/ia64/src/ia64.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ kernel/arch/ia64/src/ia64.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -127,6 +127,5 @@
 }
 
-void arch_post_cpu_init(void)
-{
+void arch_post_cpu_init(void){
 }
 
@@ -193,6 +192,5 @@
 	
 #ifdef CONFIG_I8042
-	i8042_instance_t *i8042_instance = i8042_init((i8042_t *) I8042_BASE,
-	    IRQ_KBD);
+	i8042_instance_t *i8042_instance = i8042_init((i8042_t *) I8042_BASE, IRQ_KBD);
 	if (i8042_instance) {
 		kbrd_instance_t *kbrd_instance = kbrd_init();
@@ -203,6 +201,16 @@
 		}
 	}
-#endif
-	
+	
+	sysinfo_set_item_val("i8042", NULL, true);
+	sysinfo_set_item_val("i8042.inr_a", NULL, IRQ_KBD);
+	sysinfo_set_item_val("i8042.inr_b", NULL, IRQ_MOUSE);
+	sysinfo_set_item_val("i8042.address.physical", NULL,
+	    (uintptr_t) I8042_BASE);
+	sysinfo_set_item_val("i8042.address.kernel", NULL,
+	    (uintptr_t) I8042_BASE);
+#endif
+
+	sysinfo_set_item_val("netif.ne2000.inr", NULL, IRQ_NE2000);
+
 	sysinfo_set_item_val("ia64_iospace", NULL, true);
 	sysinfo_set_item_val("ia64_iospace.address", NULL, true);
Index: tools/autotool.py
===================================================================
--- tools/autotool.py	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ tools/autotool.py	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -184,37 +184,4 @@
 	sys.stderr.write("ok\n")
 
-def check_app_alternatives(alts, args, name, details):
-	"Check whether an application can be executed (use several alternatives)"
-	
-	tried = []
-	found = None
-	
-	for alt in alts:
-		working = True
-		cmdline = [alt] + args
-		tried.append(" ".join(cmdline))
-		
-		try:
-			sys.stderr.write("Checking for %s ... " % alt)
-			subprocess.Popen(cmdline, stdout = subprocess.PIPE, stderr = subprocess.PIPE).wait()
-		except:
-			sys.stderr.write("failed\n")
-			working = False
-		
-		if (working):
-			sys.stderr.write("ok\n")
-			found = alt
-			break
-	
-	if (found is None):
-		print_error(["%s is missing." % name,
-		             "",
-		             "Please make sure that it is installed in your",
-		             "system (%s)." % details,
-		             "",
-		             "The following alternatives were tried:"] + tried)
-	
-	return found
-
 def check_gcc(path, prefix, common, details):
 	"Check for GCC"
@@ -492,8 +459,5 @@
 	
 	for key, value in common.items():
-		if (type(value) is list):
-			outmk.write('%s = %s\n' % (key, " ".join(value)))
-		else:
-			outmk.write('%s = %s\n' % (key, value))
+		outmk.write('%s = %s\n' % (key, value))
 	
 	outmk.close()
@@ -660,5 +624,5 @@
 		# Platform-specific utilities
 		if ((config['BARCH'] == "amd64") or (config['BARCH'] == "ia32") or (config['BARCH'] == "ppc32") or (config['BARCH'] == "sparc64")):
-			common['GENISOIMAGE'] = check_app_alternatives(["mkisofs", "genisoimage"], ["--version"], "ISO 9660 creation utility", "usually part of genisoimage")
+			check_app(["mkisofs", "--version"], "ISO 9660 creation utility", "usually part of genisoimage")
 		
 		probe = probe_compiler(common,
Index: uspace/app/trace/trace.c
===================================================================
--- uspace/app/trace/trace.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/app/trace/trace.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -623,4 +623,5 @@
 error:
 	loader_abort(ldr);
+	free(ldr);
 	return NULL;
 }
Index: uspace/drv/bus/isa/isa.ma
===================================================================
--- uspace/drv/bus/isa/isa.ma	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/drv/bus/isa/isa.ma	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -1,1 +1,1 @@
-9 pci/class=06&subclass=01
+9 pci/ven=8086&dev=7000
Index: uspace/drv/bus/pci/pciintel/pci.c
===================================================================
--- uspace/drv/bus/pci/pciintel/pci.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/drv/bus/pci/pciintel/pci.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -92,5 +92,5 @@
 static bool pciintel_enable_interrupt(ddf_fun_t *fnode)
 {
-	/* This is an old ugly way */
+	/* This is an old ugly way, copied from ne2000 driver */
 	assert(fnode);
 	pci_fun_t *dev_data = (pci_fun_t *) fnode->driver_data;
Index: uspace/drv/bus/usb/usbhid/mouse/mousedev.c
===================================================================
--- uspace/drv/bus/usb/usbhid/mouse/mousedev.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/drv/bus/usb/usbhid/mouse/mousedev.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -167,5 +167,5 @@
 	return result;
 }
-
+/*----------------------------------------------------------------------------*/
 static bool usb_mouse_process_report(usb_hid_dev_t *hid_dev,
     usb_mouse_t *mouse_dev)
@@ -305,5 +305,5 @@
 	return EOK;
 }
-
+/*----------------------------------------------------------------------------*/
 /** Get highest index of a button mentioned in given report.
  *
Index: uspace/drv/char/i8042/buffer.h
===================================================================
--- uspace/drv/char/i8042/buffer.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/drv/char/i8042/buffer.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -26,10 +26,8 @@
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
-
 /**
  * @addtogroup kbd
  * @{
  */
-
 /** @file
  * @brief Cyclic buffer structure.
@@ -48,26 +46,22 @@
  * Attempt to insert byte into the full buffer will block until it can succeed.
  * Attempt to read from empty buffer will block until it can succeed.
- *
  */
 typedef struct {
-	uint8_t *buffer;          /**< Storage space. */
-	uint8_t *buffer_end;      /**< End of storage place. */
-	fibril_mutex_t guard;     /**< Protects buffer structures. */
-	fibril_condvar_t change;  /**< Indicates change (empty/full). */
-	uint8_t *read_head;       /**< Place of the next readable element. */
-	uint8_t *write_head;      /**< Pointer to the next writable place. */
+	uint8_t *buffer;         /**< Storage space. */
+	uint8_t *buffer_end;     /**< End of storage place. */
+	fibril_mutex_t guard;    /**< Protects buffer structures. */
+	fibril_condvar_t change; /**< Indicates change (empty/full). */
+	uint8_t *read_head;      /**< Place of the next readable element. */
+	uint8_t *write_head;     /**< Pointer to the next writable place. */
 } buffer_t;
 
 /** Initialize cyclic buffer using provided memory space.
- *
  * @param buffer Cyclic buffer structure to initialize.
- * @param data   Memory space to use.
- * @param size   Size of the memory place.
- *
+ * @param data Memory space to use.
+ * @param size Size of the memory place.
  */
 static inline void buffer_init(buffer_t *buffer, uint8_t *data, size_t size)
 {
 	assert(buffer);
-	
 	fibril_mutex_initialize(&buffer->guard);
 	fibril_condvar_initialize(&buffer->change);
@@ -80,29 +74,27 @@
 
 /** Write byte to cyclic buffer.
- *
  * @param buffer Cyclic buffer to write to.
- * @param data   Data to write.
- *
+ * @param data Data to write.
  */
 static inline void buffer_write(buffer_t *buffer, uint8_t data)
 {
 	fibril_mutex_lock(&buffer->guard);
-	
+
 	/* Next position. */
 	uint8_t *new_head = buffer->write_head + 1;
 	if (new_head == buffer->buffer_end)
 		new_head = buffer->buffer;
-	
+
 	/* Buffer full. */
 	while (new_head == buffer->read_head)
 		fibril_condvar_wait(&buffer->change, &buffer->guard);
-	
+
 	/* Write data. */
 	*buffer->write_head = data;
-	
+
 	/* Buffer was empty. */
 	if (buffer->write_head == buffer->read_head)
 		fibril_condvar_broadcast(&buffer->change);
-	
+
 	/* Move head */
 	buffer->write_head = new_head;
@@ -111,26 +103,22 @@
 
 /** Read byte from cyclic buffer.
- *
  * @param buffer Cyclic buffer to read from.
- *
  * @return Byte read.
- *
  */
 static inline uint8_t buffer_read(buffer_t *buffer)
 {
 	fibril_mutex_lock(&buffer->guard);
-	
 	/* Buffer is empty. */
 	while (buffer->write_head == buffer->read_head)
 		fibril_condvar_wait(&buffer->change, &buffer->guard);
-	
+
 	/* Next position. */
 	uint8_t *new_head = buffer->read_head + 1;
 	if (new_head == buffer->buffer_end)
 		new_head = buffer->buffer;
-	
+
 	/* Read data. */
 	const uint8_t data = *buffer->read_head;
-	
+
 	/* Buffer was full. */
 	uint8_t *new_write_head = buffer->write_head + 1;
@@ -139,14 +127,12 @@
 	if (new_write_head == buffer->read_head)
 		fibril_condvar_broadcast(&buffer->change);
-	
+
 	/* Move head */
 	buffer->read_head = new_head;
-	
+
 	fibril_mutex_unlock(&buffer->guard);
 	return data;
 }
-
 #endif
-
 /**
  * @}
Index: uspace/drv/char/i8042/i8042.c
===================================================================
--- uspace/drv/char/i8042/i8042.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/drv/char/i8042/i8042.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -29,10 +29,8 @@
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
-
 /** @addtogroup kbd_port
  * @ingroup kbd
  * @{
  */
-
 /** @file
  * @brief i8042 PS/2 port driver.
@@ -46,55 +44,11 @@
 #include <str_error.h>
 #include <inttypes.h>
+
 #include <ddf/log.h>
 #include <ddf/interrupt.h>
+
 #include "i8042.h"
 
-/* Interesting bits for status register */
-#define i8042_OUTPUT_FULL  0x01
-#define i8042_INPUT_FULL   0x02
-#define i8042_AUX_DATA     0x20
-
-/* Command constants */
-#define i8042_CMD_WRITE_CMDB  0x60  /**< Write command byte */
-#define i8042_CMD_WRITE_AUX   0xd4  /**< Write aux device */
-
-/* Command byte fields */
-#define i8042_KBD_IE         0x01
-#define i8042_AUX_IE         0x02
-#define i8042_KBD_DISABLE    0x10
-#define i8042_AUX_DISABLE    0x20
-#define i8042_KBD_TRANSLATE  0x40  /* Use this to switch to XT scancodes */
-
-#define CHECK_RET_DESTROY(ret, msg...) \
-	do { \
-		if (ret != EOK) { \
-			ddf_msg(LVL_ERROR, msg); \
-			if (dev->kbd_fun) { \
-				dev->kbd_fun->driver_data = NULL; \
-				ddf_fun_destroy(dev->kbd_fun); \
-			} \
-			if (dev->aux_fun) { \
-				dev->aux_fun->driver_data = NULL; \
-				ddf_fun_destroy(dev->aux_fun); \
-			} \
-		} \
-	} while (0)
-
-#define CHECK_RET_UNBIND_DESTROY(ret, msg...) \
-	do { \
-		if (ret != EOK) { \
-			ddf_msg(LVL_ERROR, msg); \
-			if (dev->kbd_fun) { \
-				ddf_fun_unbind(dev->kbd_fun); \
-				dev->kbd_fun->driver_data = NULL; \
-				ddf_fun_destroy(dev->kbd_fun); \
-			} \
-			if (dev->aux_fun) { \
-				ddf_fun_unbind(dev->aux_fun); \
-				dev->aux_fun->driver_data = NULL; \
-				ddf_fun_destroy(dev->aux_fun); \
-			} \
-		} \
-	} while (0)
+#define NAME       "i8042"
 
 void default_handler(ddf_fun_t *, ipc_callid_t, ipc_call_t *);
@@ -105,9 +59,25 @@
 };
 
+/* Interesting bits for status register */
+#define i8042_OUTPUT_FULL	0x01
+#define i8042_INPUT_FULL	0x02
+#define i8042_AUX_DATA		0x20
+
+/* Command constants */
+#define i8042_CMD_WRITE_CMDB	0x60	/**< write command byte */
+#define i8042_CMD_WRITE_AUX	0xd4	/**< write aux device */
+
+/* Command byte fields */
+#define i8042_KBD_IE		0x01
+#define i8042_AUX_IE		0x02
+#define i8042_KBD_DISABLE	0x10
+#define i8042_AUX_DISABLE	0x20
+#define i8042_KBD_TRANSLATE	0x40 /* Use this to switch to XT scancodes */
+
 /** i8042 Interrupt pseudo-code. */
 static const irq_cmd_t i8042_cmds[] = {
 	{
 		.cmd = CMD_PIO_READ_8,
-		.addr = NULL,  /* will be patched in run-time */
+		.addr = NULL,	/* will be patched in run-time */
 		.dstarg = 1
 	},
@@ -125,5 +95,5 @@
 	{
 		.cmd = CMD_PIO_READ_8,
-		.addr = NULL,  /* will be patched in run-time */
+		.addr = NULL,	/* will be patched in run-time */
 		.dstarg = 2
 	},
@@ -141,40 +111,31 @@
 
 /** Interrupt handler routine.
- *
- * Write new data to the corresponding buffer.
- *
- * @param dev  Device that caued the interrupt.
- * @param iid  Call id.
+ * Writes new data to the corresponding buffer.
+ * @param dev Device that caued the interrupt.
+ * @param iid Call id.
  * @param call pointerr to call data.
- *
- */
-static void i8042_irq_handler(ddf_dev_t *dev, ipc_callid_t iid,
-    ipc_call_t *call)
-{
-	if ((!dev) || (!dev->driver_data))
+ */
+static void i8042_irq_handler(
+    ddf_dev_t *dev, ipc_callid_t iid, ipc_call_t *call)
+{
+	if (!dev || !dev->driver_data)
 		return;
-	
 	i8042_t *controller = dev->driver_data;
-	
+
 	const uint8_t status = IPC_GET_ARG1(*call);
 	const uint8_t data = IPC_GET_ARG2(*call);
-	
 	buffer_t *buffer = (status & i8042_AUX_DATA) ?
 	    &controller->aux_buffer : &controller->kbd_buffer;
-	
 	buffer_write(buffer, data);
 }
 
 /** Initialize i8042 driver structure.
- *
- * @param dev       Driver structure to initialize.
- * @param regs      I/O address of registers.
- * @param reg_size  size of the reserved I/O address space.
- * @param irq_kbd   IRQ for primary port.
+ * @param dev Driver structure to initialize.
+ * @param regs I/O address of registers.
+ * @param reg_size size of the reserved I/O address space.
+ * @param irq_kbd IRQ for primary port.
  * @param irq_mouse IRQ for aux port.
- * @param ddf_dev   DDF device structure of the device.
- *
+ * @param ddf_dev DDF device structure of the device.
  * @return Error code.
- *
  */
 int i8042_init(i8042_t *dev, void *regs, size_t reg_size, int irq_kbd,
@@ -183,15 +144,14 @@
 	assert(ddf_dev);
 	assert(dev);
-	
+
 	if (reg_size < sizeof(i8042_regs_t))
 		return EINVAL;
-	
-	if (pio_enable(regs, sizeof(i8042_regs_t), (void **) &dev->regs) != 0)
+
+	if (pio_enable(regs, sizeof(i8042_regs_t), (void**)&dev->regs) != 0)
 		return -1;
-	
+
 	dev->kbd_fun = ddf_fun_create(ddf_dev, fun_inner, "ps2a");
 	if (!dev->kbd_fun)
 		return ENOMEM;
-	
 	int ret = ddf_fun_add_match_id(dev->kbd_fun, "char/xtkbd", 90);
 	if (ret != EOK) {
@@ -199,5 +159,5 @@
 		return ret;
 	}
-	
+
 	dev->aux_fun = ddf_fun_create(ddf_dev, fun_inner, "ps2b");
 	if (!dev->aux_fun) {
@@ -205,5 +165,5 @@
 		return ENOMEM;
 	}
-	
+
 	ret = ddf_fun_add_match_id(dev->aux_fun, "char/ps2mouse", 90);
 	if (ret != EOK) {
@@ -212,22 +172,35 @@
 		return ret;
 	}
-	
+
 	dev->kbd_fun->ops = &ops;
 	dev->aux_fun->ops = &ops;
 	dev->kbd_fun->driver_data = dev;
 	dev->aux_fun->driver_data = dev;
-	
+
 	buffer_init(&dev->kbd_buffer, dev->kbd_data, BUFFER_SIZE);
 	buffer_init(&dev->aux_buffer, dev->aux_data, BUFFER_SIZE);
 	fibril_mutex_initialize(&dev->write_guard);
-	
+
+#define CHECK_RET_DESTROY(ret, msg...) \
+if  (ret != EOK) { \
+	ddf_msg(LVL_ERROR, msg); \
+	if (dev->kbd_fun) { \
+		dev->kbd_fun->driver_data = NULL; \
+		ddf_fun_destroy(dev->kbd_fun); \
+	} \
+	if (dev->aux_fun) { \
+		dev->aux_fun->driver_data = NULL; \
+		ddf_fun_destroy(dev->aux_fun); \
+	} \
+} else (void)0
+
 	ret = ddf_fun_bind(dev->kbd_fun);
-	CHECK_RET_DESTROY(ret, "Failed to bind keyboard function: %s.",
-	    str_error(ret));
-	
+	CHECK_RET_DESTROY(ret,
+	    "Failed to bind keyboard function: %s.", str_error(ret));
+
 	ret = ddf_fun_bind(dev->aux_fun);
-	CHECK_RET_DESTROY(ret, "Failed to bind mouse function: %s.",
-	    str_error(ret));
-	
+	CHECK_RET_DESTROY(ret,
+	    "Failed to bind mouse function: %s.", str_error(ret));
+
 	/* Disable kbd and aux */
 	wait_ready(dev);
@@ -235,9 +208,24 @@
 	wait_ready(dev);
 	pio_write_8(&dev->regs->data, i8042_KBD_DISABLE | i8042_AUX_DISABLE);
-	
+
 	/* Flush all current IO */
 	while (pio_read_8(&dev->regs->status) & i8042_OUTPUT_FULL)
 		(void) pio_read_8(&dev->regs->data);
-	
+
+#define CHECK_RET_UNBIND_DESTROY(ret, msg...) \
+if  (ret != EOK) { \
+	ddf_msg(LVL_ERROR, msg); \
+	if (dev->kbd_fun) { \
+		ddf_fun_unbind(dev->kbd_fun); \
+		dev->kbd_fun->driver_data = NULL; \
+		ddf_fun_destroy(dev->kbd_fun); \
+	} \
+	if (dev->aux_fun) { \
+		ddf_fun_unbind(dev->aux_fun); \
+		dev->aux_fun->driver_data = NULL; \
+		ddf_fun_destroy(dev->aux_fun); \
+	} \
+} else (void)0
+
 	const size_t cmd_count = sizeof(i8042_cmds) / sizeof(irq_cmd_t);
 	irq_cmd_t cmds[cmd_count];
@@ -245,20 +233,16 @@
 	cmds[0].addr = (void *) &dev->regs->status;
 	cmds[3].addr = (void *) &dev->regs->data;
-	
-	irq_code_t irq_code = {
-		.cmdcount = cmd_count,
-		.cmds = cmds
-	};
-	
+
+	irq_code_t irq_code = { .cmdcount = cmd_count, .cmds = cmds };
 	ret = register_interrupt_handler(ddf_dev, irq_kbd, i8042_irq_handler,
 	    &irq_code);
-	CHECK_RET_UNBIND_DESTROY(ret, "Failed set handler for kbd: %s.",
-	    str_error(ret));
-	
+	CHECK_RET_UNBIND_DESTROY(ret,
+	    "Failed set handler for kbd: %s.", str_error(ret));
+
 	ret = register_interrupt_handler(ddf_dev, irq_mouse, i8042_irq_handler,
 	    &irq_code);
-	CHECK_RET_UNBIND_DESTROY(ret, "Failed set handler for mouse: %s.",
-	    str_error(ret));
-	
+	CHECK_RET_UNBIND_DESTROY(ret,
+	    "Failed set handler for mouse: %s.", str_error(ret));
+
 	/* Enable interrupts */
 	async_sess_t *parent_sess =
@@ -267,10 +251,10 @@
 	ret = parent_sess ? EOK : ENOMEM;
 	CHECK_RET_UNBIND_DESTROY(ret, "Failed to create parent connection.");
-	
+
 	const bool enabled = hw_res_enable_interrupt(parent_sess);
 	async_hangup(parent_sess);
 	ret = enabled ? EOK : EIO;
 	CHECK_RET_UNBIND_DESTROY(ret, "Failed to enable interrupts: %s.");
-	
+
 	/* Enable port interrupts. */
 	wait_ready(dev);
@@ -279,9 +263,9 @@
 	pio_write_8(&dev->regs->data, i8042_KBD_IE | i8042_KBD_TRANSLATE |
 	    i8042_AUX_IE);
-	
+
 	return EOK;
 }
 
-// FIXME TODO use shared instead this
+// TODO use shared instead this
 enum {
 	IPC_CHAR_READ = DEV_FIRST_CUSTOM_METHOD,
@@ -290,11 +274,8 @@
 
 /** Write data to i8042 port.
- *
- * @param fun    DDF function.
+ * @param fun DDF function.
  * @param buffer Data source.
- * @param size   Data size.
- *
+ * @param size Data size.
  * @return Bytes written.
- *
  */
 static int i8042_write(ddf_fun_t *fun, char *buffer, size_t size)
@@ -302,19 +283,13 @@
 	assert(fun);
 	assert(fun->driver_data);
-	
 	i8042_t *controller = fun->driver_data;
 	fibril_mutex_lock(&controller->write_guard);
-	
 	for (size_t i = 0; i < size; ++i) {
-		if (controller->aux_fun == fun) {
-			wait_ready(controller);
-			pio_write_8(&controller->regs->status,
-			    i8042_CMD_WRITE_AUX);
-		}
-		
 		wait_ready(controller);
+		if (controller->aux_fun == fun)
+			pio_write_8(
+			    &controller->regs->status, i8042_CMD_WRITE_AUX);
 		pio_write_8(&controller->regs->data, buffer[i]);
 	}
-	
 	fibril_mutex_unlock(&controller->write_guard);
 	return size;
@@ -322,11 +297,8 @@
 
 /** Read data from i8042 port.
- *
- * @param fun    DDF function.
+ * @param fun DDF function.
  * @param buffer Data place.
- * @param size   Data place size.
- *
+ * @param size Data place size.
  * @return Bytes read.
- *
  */
 static int i8042_read(ddf_fun_t *fun, char *data, size_t size)
@@ -334,21 +306,18 @@
 	assert(fun);
 	assert(fun->driver_data);
-	
+
 	i8042_t *controller = fun->driver_data;
 	buffer_t *buffer = (fun == controller->aux_fun) ?
 	    &controller->aux_buffer : &controller->kbd_buffer;
-	
-	for (size_t i = 0; i < size; ++i)
+	for (size_t i = 0; i < size; ++i) {
 		*data++ = buffer_read(buffer);
-	
+	}
 	return size;
 }
 
 /** Handle data requests.
- *
- * @param fun  ddf_fun_t function.
- * @param id   callid
+ * @param fun ddf_fun_t function.
+ * @param id callid
  * @param call IPC request.
- *
  */
 void default_handler(ddf_fun_t *fun, ipc_callid_t id, ipc_call_t *call)
@@ -356,35 +325,31 @@
 	const sysarg_t method = IPC_GET_IMETHOD(*call);
 	const size_t size = IPC_GET_ARG1(*call);
-	
 	switch (method) {
 	case IPC_CHAR_READ:
 		if (size <= 4 * sizeof(sysarg_t)) {
 			sysarg_t message[4] = {};
-			
-			i8042_read(fun, (char *) message, size);
+			i8042_read(fun, (char*)message, size);
 			async_answer_4(id, size, message[0], message[1],
 			    message[2], message[3]);
-		} else
+		} else {
 			async_answer_0(id, ELIMIT);
+		}
 		break;
-	
+
 	case IPC_CHAR_WRITE:
 		if (size <= 3 * sizeof(sysarg_t)) {
 			const sysarg_t message[3] = {
-				IPC_GET_ARG2(*call),
-				IPC_GET_ARG3(*call),
-				IPC_GET_ARG4(*call)
-			};
-			
-			i8042_write(fun, (char *) message, size);
+				IPC_GET_ARG2(*call), IPC_GET_ARG3(*call),
+				IPC_GET_ARG4(*call) };
+			i8042_write(fun, (char*)message, size);
 			async_answer_0(id, size);
-		} else
+		} else {
 			async_answer_0(id, ELIMIT);
-	
+		}
+
 	default:
 		async_answer_0(id, EINVAL);
 	}
 }
-
 /**
  * @}
Index: uspace/drv/char/i8042/i8042.h
===================================================================
--- uspace/drv/char/i8042/i8042.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/drv/char/i8042/i8042.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -27,10 +27,8 @@
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
-
 /** @addtogroup kbd_port
  * @ingroup  kbd
  * @{
  */
-
 /** @file
  * @brief i8042 port driver.
@@ -43,9 +41,8 @@
 #include <fibril_synch.h>
 #include <ddf/driver.h>
+
 #include "buffer.h"
 
-#define NAME  "i8042"
-
-#define BUFFER_SIZE  12
+#define BUFFER_SIZE 12
 
 /** i8042 HW I/O interface */
@@ -58,9 +55,9 @@
 /** i8042 driver structure. */
 typedef struct i8042 {
-	i8042_regs_t *regs;             /**< I/O registers. */
-	ddf_fun_t *kbd_fun;             /**< Pirmary port device function. */
-	ddf_fun_t *aux_fun;             /**< Auxiliary port device function. */
-	buffer_t kbd_buffer;            /**< Primary port buffer. */
-	buffer_t aux_buffer;            /**< Aux. port buffer. */
+	i8042_regs_t *regs;    /**< I/O registers. */
+	ddf_fun_t *kbd_fun;    /**< Pirmary port device function. */
+	ddf_fun_t *aux_fun;  /**< Auxiliary port device function. */
+	buffer_t kbd_buffer;   /**< Primary port buffer. */
+	buffer_t aux_buffer;   /**< Aux. port buffer. */
 	uint8_t aux_data[BUFFER_SIZE];  /**< Primary port buffer space. */
 	uint8_t kbd_data[BUFFER_SIZE];  /**< Aux. port buffer space. */
@@ -69,7 +66,5 @@
 
 int i8042_init(i8042_t *, void *, size_t, int, int, ddf_dev_t *);
-
 #endif
-
 /**
  * @}
